/******************************************************************
 * @file  ape_common.h
 * @brief:    [file description]
 * @author: xuekun.zhang
 * @Date 2022年1月11日
 * COPYRIGHT NOTICE: (c) smartlogictech. All rights reserved.
 * Change_date         Owner         Change_content
 * 2022年1月11日        xuekun.zhang       create file

*****************************************************************/

#ifndef     APE_COMMON_H
#define     APE_COMMON_H

/**************************include******************************/
#include "type_define.h"

#define  APE_DM0      DM0 
#define  APE_DM1      DM1 
#define  APE_DM2      DM2 
#define  APE_DM3      DM3 
#define  __APE_DM0   __DM0
#define  __APE_DM1   __DM1
#define  __APE_DM2   __DM2
#define  __APE_DM3   __DM3

#define DM_TO_CSU_ADDR(addr)	(((uint32_t)(addr)) - 0x100000)
#define IM_TO_CSU_ADDR(addr)	((uint32_t)(addr))

#define DMA_TAG_G2L		0
#define DMA_TAG_L2G 	1
#define DMA_TAG_G2G 	2
#define DMA_TAG_CHAIN	3

extern __APE_DM3 v16s32 SVRReg;

#endif
