/******************************************************************
 * @file  receiver_bit_func.h
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年4月20日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年4月20日        HUOHUO       create file
*****************************************************************/
#ifndef RECEIVER_BIT_FUNC_H
#define RECEIVER_BIT_FUNC_H
/****************************include*****************************/
#include "common.h"
#include "mem_def.h"
#include "phy_macro.h"
#include "receiver_bit_macro.h"
#include "receiver_bit_struct.h"
#include "ape_common.h"
#include "drv_ape.h"
#include "log_interface.h"
#include "msg_interface.h"
#include "osp_ape.h"
#include "task_define.h"
#include "trace.h"
//include mpu header files



//微码配置空间偏移结构体
extern receiver_bit_table_param_t  g_receiver_bit_table_param;
extern uint32_t *receiver_bit_config_dm0_ptr;
extern uint32_t *receiver_bit_config_dm1_ptr;
extern uint32_t *receiver_bit_config_dm2_ptr;
extern uint32_t *receiver_bit_config_dm3_ptr;

void Receiver_Bit_Init();
void Receiver_Bit_Task(void* msg_ptr, uint32_t msg_len);
void Receiver_Bit_Proc(
    uint32_t* param_ptr,
    int32_t* temp_dm0_ptr,
    int32_t* temp_dm1_ptr,
    int32_t* temp_dm2_ptr,
    int32_t* temp_dm3_ptr
);

#endif
