/******************************************************************
 * @file  ape_common.c
 * @brief:    [file description]
 * @author: xuekun.zhang
 * @Date 2022年1月11日
 * COPYRIGHT NOTICE: (c) smartlogictech. All rights reserved.
 * Change_date         Owner         Change_content
 * 2022年1月11日        xuekun.zhang       create file

*****************************************************************/

/**************************include******************************/
#include <ape_common.h>
#include "log_interface.h"
/**************************function******************************/

//微码配置寄存器
__APE_DM3 v16s32 SVRReg  = {
		0, 0, 0, 0,
		0x40, 0, 0, 0,
		0xff00ff, 0, 0, 0x0000,
		0xffff, 0x6, 0, 0
};

//uint32_t g_dma_tag_g2l = DMA_TAG_G2L;
uint32_t g_dma_tag_l2g = DMA_TAG_L2G;
////自定义空间的log头定义
__APE_DM3 uint32_t g_ape_log_header[(LOG_TOTAL_HDR_SIZE + 3)>>2];
//静态申请log空间
__APE_DM3 uint32_t g_ape_log_static_buf[LOG_DM_BUF_NUM * LOG_MAX_LEN_WORD];//log 宏定义修改，原宏名表达不准确


