/******************************************************************
 * @file  receiver_Proc.s.c
 * @brief:    [file description] 
 * @author: HUOHUO
 * @Date 2024年4月20日
 * COPYRIGHT NOTICE: ITTC
 * Change_date         Owner         Change_content
 * 2024年4月20日        HUOHUO       create file

*****************************************************************/
#include "receiver_bit_func.h"

 /*!   
 * @brief:  Receiver_sync链路处理
 * @author:  HUOHUO
 * @Date:  2024年10月30日
 */
void Receiver_Bit_Proc(
    uint32_t *param_ptr,
    int32_t  *temp_dm0_ptr,
    int32_t  *temp_dm1_ptr,
    int32_t  *temp_dm2_ptr,
    int32_t  *temp_dm3_ptr
)
{
    //局部变量定义
    int32_t  *cfg_addr;
    uint32_t time_data_ddr_ptr;
    uint32_t time_data_length;
    uint32_t mpu_temp_dm0_ptr;
    uint32_t mpu_temp_dm1_ptr;
    uint32_t mpu_temp_dm2_ptr;
    uint32_t mpu_temp_dm3_ptr;
    uint32_t temp_u32;
    uint32_t time_data_dm0_ptr = ((((uint32_t)&temp_dm0_ptr[0] + 4095)>>12)<<12);
    uint32_t res_ptr = RECEIVER_OUT3;

    //data读入
    //获取源数据地址
    time_data_ddr_ptr = (uint32_t)*param_ptr;
    time_data_length = (uint32_t)((*(param_ptr + 1) +7)>>3);//计算byte数
    ape_csu_task_lookup(DMA_TAG_G2L, 1);

    // ape_csu_dma_1D_G2L_ch0ch1_transfer((uint64_t)time_data_ddr_ptr,
    //                          (uint64_t)DM_TO_CSU_ADDR(time_data_dm0_ptr),
    //                          time_data_length,
    //                          DMA_TAG_G2L,
    //                          0);



    // //计算结果搬移到外存
    // temp_u32 = 1000;//计算byte数
    // WAIT_MPU_STOP;
    // ape_csu_task_lookup(DMA_TAG_G2L, 1);
    
    // ape_csu_dma_1D_L2G_ch0ch1_transfer((uint64_t)DM_TO_CSU_ADDR(time_data_dm0_ptr),
    //                         (uint64_t)res_ptr,
    //                         temp_u32,
    //                         DMA_TAG_L2G,
    //                         1);

    return;
}
