#ifndef TEST_FUNC_H
#define TEST_FUNC_H
#ifdef IDE_TEST
#include "type_define.h"


#define RECEIVER_IDE_BASE_ADDR	((uint32_t)g_deofdm_test_file)

#define RECEIVER_IDE_CONFIG_DM0_ADDR	(RECEIVER_IDE_BASE_ADDR)
#define RECEIVER_IDE_CONFIG_DM0_LEN	(0x0)
#define RECEIVER_IDE_CONFIG_DM1_ADDR	(RECEIVER_IDE_CONFIG_DM0_ADDR + RECEIVER_IDE_CONFIG_DM0_LEN)
#define RECEIVER_IDE_CONFIG_DM1_LEN	(0x0280)
#define RECEIVER_IDE_CONFIG_DM2_ADDR	(RECEIVER_IDE_CONFIG_DM1_ADDR + RECEIVER_IDE_CONFIG_DM1_LEN)
#define RECEIVER_IDE_CONFIG_DM2_LEN	(0xC000)
#define RECEIVER_IDE_CONFIG_DM3_ADDR	(RECEIVER_IDE_CONFIG_DM2_ADDR + RECEIVER_IDE_CONFIG_DM2_LEN)
#define RECEIVER_IDE_CONFIG_DM3_LEN	(0xC000)

#define RECEIVER_IDE_TIME_DATA_ADDR	(RECEIVER_IDE_CONFIG_DM3_ADDR + RECEIVER_IDE_CONFIG_DM3_LEN)
#define RECEIVER_IDE_TIME_DATA_LEN	    (0x0F81)


#define TRANSMITTER_IDE_BASE_ADDR	((uint32_t)g_deofdm_test_file)

#define TRANSMITTER_IDE_CONFIG_DM0_ADDR	(TRANSMITTER_IDE_BASE_ADDR)
#define TRANSMITTER_IDE_CONFIG_DM0_LEN	(0x0)
#define TRANSMITTER_IDE_CONFIG_DM1_ADDR	(TRANSMITTER_IDE_CONFIG_DM0_ADDR + TRANSMITTER_IDE_CONFIG_DM0_LEN)
#define TRANSMITTER_IDE_CONFIG_DM1_LEN	(0x5660)
#define TRANSMITTER_IDE_CONFIG_DM2_ADDR	(TRANSMITTER_IDE_CONFIG_DM1_ADDR + TRANSMITTER_IDE_CONFIG_DM1_LEN)
#define TRANSMITTER_IDE_CONFIG_DM2_LEN	(0x0)
#define TRANSMITTER_IDE_CONFIG_DM3_ADDR	(TRANSMITTER_IDE_CONFIG_DM2_ADDR + TRANSMITTER_IDE_CONFIG_DM2_LEN)
#define TRANSMITTER_IDE_CONFIG_DM3_LEN	(0x0)//

#define TRANSMITTER_IDE_SRC_BIT_ADDR	(TRANSMITTER_IDE_CONFIG_DM3_ADDR + TRANSMITTER_IDE_CONFIG_DM3_LEN)
#define TRANSMITTER_IDE_SRC_BIT_LEN	    (0x3E90)//bit/8


int osp_get_cfgfile(char* name, uint32_t *pbuf, int* psize);
int get_core_id();
int get_rx_nr_slot();
int get_rx_nr_sfn(uint8_t scs);

#endif
#endif